%define debug_package %{nil}
%global gomodulesmode GO111MODULE=on

Summary:    Prometheus Alertmanager
Name:       alertmanager
Version:    0.25.0
Release:    5%{?dist}
License:    ASL 2.0
URL:        https://github.com/prometheus/alertmanager
Source0:    %{url}/archive/refs/tags/v%{version}.tar.gz
# cd %%{name}-%%{version}
# go mod vendor
# tar -zcf vendor.tar.gz vendor/
Source1:    vendor.tar.gz
Source2:    %{name}.service
Source3:    %{name}.default
Source4:    %{name}.yml

BuildRequires: golang systemd go-rpm-macros
%{?systemd_requires}

Requires(pre): shadow-utils

%description
The Alertmanager handles alerts sent by client applications
such as the Prometheus server. It takes care of deduplicating,
grouping, and routing them to the correct receiver integrations
such as email, PagerDuty, OpsGenie, or many other mechanisms
thanks to the webhook receiver. It also takes care of silencing
and inhibition of alerts.


%prep
%autosetup -n %{name}-%{version} -a1

%build
%gobuild -o %{_builddir}/%{name}-%{version}/bin/alertmanager ./cmd/alertmanager
%gobuild -o %{_builddir}/%{name}-%{version}/bin/amtool ./cmd/amtool

%install
mkdir -vp %{buildroot}%{_sharedstatedir}/prometheus/alertmanager
install -D -m 755 -vd %{buildroot}%{_bindir}
install -D -m 755 -vp %{_builddir}/%{name}-%{version}/bin/*  %{buildroot}%{_bindir}
install -D -m 644 %{SOURCE2} %{buildroot}%{_unitdir}/%{name}.service
install -D -m 644 %{SOURCE3} %{buildroot}%{_sysconfdir}/default/%{name}
install -D -m 644 %{SOURCE4} %{buildroot}%{_sysconfdir}/prometheus/%{name}.yml

%pre
getent group prometheus >/dev/null || groupadd -r prometheus
getent passwd prometheus >/dev/null || \
  useradd -r -g prometheus -d %{_sharedstatedir}/prometheus -s /sbin/nologin \
          -c "Prometheus services" prometheus
exit 0

%post
%systemd_post %{name}.service

%preun
%systemd_preun %{name}.service

%postun
%systemd_postun_with_restart %{name}.service

%files
%defattr(-,root,root,-)
%config(noreplace) %{_sysconfdir}/prometheus/%{name}.yml
%{_bindir}/%{name}
%{_bindir}/amtool
%{_unitdir}/%{name}.service
%config(noreplace) %{_sysconfdir}/default/%{name}
%dir %attr(755, prometheus, prometheus)%{_sharedstatedir}/prometheus/alertmanager

%changelog
* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.25.0-5
- Rebuilt for OpenCloudOS Stream 23.09

* Tue May 16 2023 Miaojun Dong <zoedong@tencent.com> - 0.25.0-4
- fix conflict with prometheus installation directory

* Fri May 05 2023 Miaojun Dong <zoedong@tencent.com> - 0.25.0-3
- add instructions for generating vendor.tar.gz

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.25.0-2
- Rebuilt for OpenCloudOS Stream 23.05

* Tue Apr 18 2023 Miaojun Dong <zoedong@tencent.com> - 0.25.0-1
- initial build
